<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>List of orders</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">DANH SÁCH ĐƠN HÀNG</h2>
    
    <table class="table table-bordered table-striped table-hover" id="order-table">
      <thead>
        <tr>
          <th>Order Code</th>
          <th>Kích cỡ combo</th>
          <th>Loại pizza</th>
          <th>Nước uống</th>
          <th>Thành tiền</th>
          <th>Họ và tên</th>
          <th>Số điện thoại</th>
          <th>Trạng thái</th>
          <th>Chi tiết</th>
        </tr>
    </table>
  </div>
  <!-- Order detail modal -->
  <div>
    <div id="order-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Order Detail !!!</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-order-code">Order Code</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-order-code" name="ordercode" placeholder="Order code"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-combo">Pizza Size</label>
                </div>
                <div class="col-sm-8">
                  <select type="select" id="select-combo" name="combo" class="form-control">
                    <option value="S">S</option>
                    <option value="M">M</option>
                    <option value="L">L</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-duong-kinh">Đường kính</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-duong-kinh" name="duongkinh" placeholder="Đường kính"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-suon">Sườn</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-suon" name="suon" placeholder="Sườn (miếng)" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-salad">Salad</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-salad" name="salad" placeholder="Salad (gr)" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-pizza">Pizza Type</label>
                </div>
                <div class="col-sm-8">
                  <select type="select" id="select-pizza" name="pizza" class="form-control">
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-id-voucher">Id Voucher</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-id-voucher" name="idvoucher" placeholder="Id Voucher"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-thanh-tien">Thành tiền</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-thanh-tien" name="price" placeholder="Thành tiền" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-giam-gia">Giảm giá</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-giam-gia" name="discount" placeholder="Giảm giá" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="select-drink">Loại đồ uống</label>
                </div>
                <div class="col-sm-8">
                  <select type="select" id="select-drink" name="drink" class="form-control"></select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-so-luong-nuoc-uong">Số lượng nước uống</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-so-luong-nuoc-uong" name="soluongnuoc" placeholder="Số lượng nước uống"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-name">Họ và tên</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-name" name="name" placeholder="Họ và tên" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-email">Email</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-email" name="email" placeholder="Email" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-phone">Số điện thoại</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-phone" name="phone" placeholder="Số điện thoại" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-dia-chi">Địa chỉ</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-dia-chi" name="address" placeholder="Địa chỉ" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-message">Lời nhắn</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-message" name="message" placeholder="Lời nhắn" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-order-date">Ngày order</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-order-date" name="orderdate" placeholder="Ngày order"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="input-edit-date">Ngày chỉnh sửa</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-edit-date" name="editdate" placeholder="Ngày chỉnh sửa"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-6">
                  <button class="col-sm-12 btn btn-warning" id="btn-confirm">Confirm</button>
                </div>
                <div class="col-sm-6">
                  <button class="col-sm-12 btn btn-danger" id="btn-cancel">Cancel</button>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-close" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  "use strict";
 
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrdersArr = [];
    const gCOLUMN_CODE = 0;
    const gCOLUMN_COMBO = 1;
    const gCOLUMN_PIZZA = 2;
    const gCOLUMN_DRINK = 3;
    const gCOLUMN_AMOUNT = 4;
    const gCOLUMN_NAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_ORDER_STATUS = 7;
    const gCOLUMN_DETAIL = 8;

    const gUSER_COL = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "detail"]

    var gOrderId = "";
    var gOrderCode = "";
    var gOrderObj = "";

    // set and mapping data table
    var gOrderTable = $("#order-table").DataTable({
      "columns": [
        { "data": gUSER_COL[gCOLUMN_CODE] },
        { "data": gUSER_COL[gCOLUMN_COMBO] },
        { "data": gUSER_COL[gCOLUMN_PIZZA] },
        { "data": gUSER_COL[gCOLUMN_DRINK] },
        { "data": gUSER_COL[gCOLUMN_AMOUNT] },
        { "data": gUSER_COL[gCOLUMN_NAME] },
        { "data": gUSER_COL[gCOLUMN_PHONE] },
        { "data": gUSER_COL[gCOLUMN_ORDER_STATUS] },
        { "data": gUSER_COL[gCOLUMN_DETAIL] }
      ],
      
      "columnDefs": [
        {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": "<button class='info-order btn btn-primary'>Chi tiết</button>"
        }]
    });

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
   
    $(document).ready(function () {

    onPageLoading();
    
    //add event on loading the drink list
    getDrinkListAjaxClick();

    // add event for the detail button
    $("#order-table").on("click", ".info-order", function () {
      onBtnDetailClick(this); 
    });

    // add event for the confirm button
    $("#btn-confirm").on("click", function () {
      onBtnConfirmClick(this); 
    });

    // add event for the cancel button
    $("#btn-cancel").on("click", function () {
      onBtnCancelClick(this); 
    });

  })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    // function for loading page
    function onPageLoading() {
      
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        dataType: 'json',
        success: function (responseObject) {
          //debugger;
          gOrdersArr = responseObject;
          loadDataToTable(responseObject);
        },
        error: function (error) {
          console.assert(error.responseText);
        }
      });
    }
    
    //function for Detail Button
    function onBtnDetailClick(paramChiTietButton) {
     
      var vRowSelected = $(paramChiTietButton).parents('tr');
      var vDatatableRow = gOrderTable.row(vRowSelected);
      var vOrderData = vDatatableRow.data();
      
      gOrderId = vOrderData.id;
      gOrderCode = vOrderData.orderCode;
      
      console.log("Order id: " + gOrderId);
      console.log("Order code: " + gOrderCode);
     
      getAjaxDetailOrder(gOrderCode);
      $("#order-modal").modal("show");
    }
    
    //function for Confirm Button
    function onBtnConfirmClick() {
      
      console.log("Order ID: " + gOrderId);
      var vObjectRequest = {
          trangThai: "confirmed" 
      };
      var vJsonString = JSON.stringify(vObjectRequest);
      
      console.log(vJsonString);


      getAjaxUpdateOrderStatus(gOrderId, vJsonString);
   
      console.log("Order đã được xác nhận!");
      $("#order-modal").modal("hide");
    }
    
    //funtion for Cancel Button
    function onBtnCancelClick() {
          
      console.log("Order ID: " + gOrderId);
      var vObjectRequest = {
          trangThai: "cancel" 
      };
      var vJsonString = JSON.stringify(vObjectRequest);
      getAjaxUpdateOrderStatus(gOrderId, vJsonString);
     
      console.log("Order đã được hủy!");
      $("#order-modal").modal("hide");
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    
    //function to call API for getting orderCode
    function getAjaxDetailOrder(paramOrderCode) {
     
      $.ajax({
        url: gBASE_URL + "/" + paramOrderCode,
        type: "GET",
        dataType: 'json',
        success: function (res) {
          //debugger;
          handleOrderDetail(res);
          gOrderObj = res;
        },
        error: function (ajaxContext) {
          console.log(ajaxContext.status);
        }
      });
    }
    
    // load data to table
    function loadDataToTable(paramResponseObject) {
      
      gOrderTable.clear();
      gOrderTable.rows.add(paramResponseObject);
      gOrderTable.draw();
    }
    
    //function to call API for getting the drink list
    function getDrinkListAjaxClick() {
      
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
        dataType: "json",
        type: "GET",
        success: function (res) {
          console.log(res);
          handleDrinkList(res);
        },
        error: function (ajaxContext) {
          console.log(ajaxContext.responseText);
        }
      });
    }
    
    //function for loading the drink list to select
    function handleDrinkList(paramDrink) {
    
      var vArrayDrinkList = paramDrink;
      //load data to drink select
      var vSelectDrink = document.getElementById("select-drink");
      for (var bI = 0; bI < vArrayDrinkList.length; bI++) {
        var vDrinkOption = document.createElement("option");
        vDrinkOption.value = vArrayDrinkList[bI].maNuocUong;
        vDrinkOption.text = vArrayDrinkList[bI].tenNuocUong;
        vSelectDrink.appendChild(vDrinkOption);
      }
    }
    
    //function for order detail modal
    function handleOrderDetail(paramOrderObj) {
     
      $("#input-order-code").val(paramOrderObj.orderCode);
      $("#select-combo").val(paramOrderObj.kichCo);
      $("#input-duong-kinh").val(paramOrderObj.duongKinh);
      $("#input-suon").val(paramOrderObj.suon);
      $("#input-salad").val(paramOrderObj.salad);
      $("#select-pizza").val(paramOrderObj.loaiPizza);
      $("#input-id-voucher").val(paramOrderObj.idVourcher);
      $("#input-thanh-tien").val(paramOrderObj.thanhTien);
      $("#input-giam-gia").val(paramOrderObj.giamGia);
      $("#select-drink").val(paramOrderObj.idLoaiNuocUong);
      $("#input-so-luong-nuoc-uong").val(paramOrderObj.soLuongNuoc);

      $("#input-name").val(paramOrderObj.hoTen);
      $("#input-email").val(paramOrderObj.email);
      $("#input-phone").val(paramOrderObj.soDienThoai);
      $("#input-dia-chi").val(paramOrderObj.diaChi);
      $("#input-message").val(paramOrderObj.loiNhan);

      $("#input-order-date").val(paramOrderObj.ngayTao);
      $("#input-edit-date").val(paramOrderObj.ngayCapNhat);

    }
    
    //function to call API for updating confirm status
    function getAjaxUpdateOrderStatus(paramOrderId, paramJsonString) {
      
      console.log(paramOrderId)
      console.log(paramJsonString)

      $.ajax({
        url: gBASE_URL + "/" + paramOrderId,
        data: paramJsonString,
        type: "PUT",
        async: false,
        contentType: "application/json", 
        success: function (res) {
          alert("Order Id - " + res.id + " is updated succesfully!");
          console.log("%cUPDATED INFORMATION: ", "color:orange");
          console.log(res);
        },
        error: function (ajaxContext) {
          console.log(ajaxContext.status);
        }
      });
    }
  
  
</script>

</html>